
let MainSTG = GetMainStgScriptDirectory;
let FuncSrc;

local{
	FuncSrc = GetCurrentScriptDirectory;
}


let AllStarSource = "";

local{
	AllStarSource = GetCurrentScriptDirectory;
	let scriptEffect = LoadScript(AllStarSource~"Effect.dnh");
	StartScript(scriptEffect);
}


let SpellAttack_img = AllStarSource~"img/SpellAttack.png"; 
let img_SpellAttack = AllStarSource~"img/effect3/effect37.png"; // Spell Declare

let Alpha_HUD = [255, 255]; //top, bottom


task CutinM1(Type, SpellName, Images, Colors, sscore){
	if(length(Images)>15){
		Images = [Images];
		Colors = [Colors];
	}
	if(Type == "NAZRIN"){
		SpellText(0);
		SpellAttackEffect(145);
		FireCutinA1(GetStgFrameWidth+224, GetStgFrameHeight/2-128, 158, 20.6, 20, 0.65, 90, Images[0]);
	}
	else if(Type == "MOKOU"){
		SpellText(0);
	}
	
	
	task FireCutinA1(x, y, angle, ispeed, itime, mspeed, mtime, img){		
		let SpellCutin = CreateSimple2DImageA1(0.29, img);
		ObjRender_SetPosition(SpellCutin, x, y, 0);
		ObjRender_SetAlpha(SpellCutin, 0);
		
		
		
		let len = itime;
		ascent(x in 0..len){
			let mod = x/len;
			let locs = [ObjRender_GetX(SpellCutin), ObjRender_GetY(SpellCutin)];
			ObjRender_SetPosition(SpellCutin, floor(locs[0]+ispeed*cos(angle)), floor(locs[1]+ispeed*sin(angle)), 0);
			
			let alph = min(255, 255*(mod*2));
			ObjRender_SetAlpha(SpellCutin, alph);
			yield;
		}
		
		len = mtime;
		let nx = ObjRender_GetX(SpellCutin);
		let ny = ObjRender_GetY(SpellCutin);
		ascent(x in 0..len){
			let locs = [ObjRender_GetX(SpellCutin), ObjRender_GetY(SpellCutin)];
			locs[0] = locs[0]+mspeed*cos(angle);
			locs[1] = locs[1]+mspeed*sin(angle);
			nx += mspeed*cos(angle);
			ny += mspeed*sin(angle);
			ObjRender_SetPosition(SpellCutin, floor(nx), floor(ny), 0);
			yield;
		}
		//return;
		len = mtime;
		ascent(x in 0..len){
			let mod = x/len;
			let locs = [ObjRender_GetX(SpellCutin), ObjRender_GetY(SpellCutin)];
			ObjRender_SetPosition(SpellCutin, floor(locs[0]+ispeed*cos(angle)), floor(locs[1]+ispeed*sin(angle)), 0);
			yield;
		}
		Obj_Delete(SpellCutin);
	}
	
	task SpellText(delay){
		//These are long-looking common data group names
		let SpellDataAttempt = SpellName~"|"~IntToString(GetCommonData("Difficulty", "AllStar"))~"|"~GetPlayerID~"|"~"Attempt";
		let SpellDataGet = SpellName~"|"~IntToString(GetCommonData("Difficulty", "AllStar"))~"|"~GetPlayerID~"|"~"Get";
		//This is actually the common data retrieval
		let SpellValueAttempt = GetAreaCommonData("Score", SpellDataAttempt, 0);
		let SpellValueGet = GetAreaCommonData("Score", SpellDataGet, 0);
		
		
		if(!IsReplay&&!DEBUG){
			SpellValueAttempt++;
			SetAreaCommonData("Score", SpellDataAttempt, SpellValueAttempt);
			SaveCommonDataAreaA1("Score");
		}
	
	
		let SpellBG = CreateSimple2DImageA2(0.8, SpellAttack_img, 0, 0, 255, 31);
		ObjSprite2D_SetDestRect(SpellBG, -224, -12, 32, 20);
		ObjRender_SetPosition(SpellBG, 340, 320, 0);
		ObjRender_SetAlpha(SpellBG, 0);
		ObjRender_SetColor(SpellBG, Colors[0][0], Colors[0][1], Colors[0][2]);
		
		let SpellText = ObjText_Create;
		ObjText_SetText(SpellText,SpellName);
		ObjText_SetFontSize(SpellText,12);
		ObjText_SetFontColorTop(SpellText,255,255,255);
		ObjText_SetFontColorBottom(SpellText, Colors[0][0], Colors[0][1], Colors[0][2]);
		ObjText_SetFontBorderType(SpellText,BORDER_FULL);
		ObjText_SetFontBorderColor(SpellText,32,32,32);
		ObjText_SetFontBorderWidth(SpellText,1);
		ObjText_SetHorizontalAlignment(SpellText, ALIGNMENT_RIGHT);
		ObjText_SetMaxWidth(SpellText, GetStgFrameWidth-24);
		Obj_SetRenderPriority(SpellText, 0.8);
		ObjRender_SetPosition(SpellText, 0, 320, 0);
		ObjRender_SetAlpha(SpellText, 0);
		
		
		let SpellInfo = ObjPrim_Create(OBJ_SPRITE_LIST_2D);
		let bonus = sscore;
		let count = GetNumSize(bonus);
		let scount = max(2, GetNumSize(SpellValueAttempt));
		ObjPrim_SetTexture(SpellInfo, SpellAttack_img);
		ObjRender_SetBlendType(SpellInfo, BLEND_ALPHA);
		Obj_SetRenderPriority(SpellInfo, 0.8);
		ObjRender_SetY(SpellInfo, 36);
		ObjRender_SetAlpha(SpellInfo, 0);
		
		//-------------Introduction--------------------------
		
		loop(delay){yield;}
		let len = 30;
		ascent(i in 0..len){
			let mod = i/len;
			let tmod = min(1, ((i*2)/len));
			ObjRender_SetScaleXYZ(SpellBG, 4-3*mod, 4-3*mod, 1);
			ObjRender_SetAlpha(SpellBG, 255*mod);
			ObjRender_SetX(SpellText, (GetStgFrameWidth-24)*(1-mod));
			//ObjRender_SetScaleXYZ(SpellText, 4-3*tmod, 4-3*tmod, 1);
			ObjRender_SetAlpha(SpellText, 255*tmod);
			yield;
		}
		loop(40){yield;}
		let mov = 0;
		
		if(Type == "MOKOU"){SpellcardDeclareMovement([ObjRender_GetY(SpellText), 48, 0.175, 9]);loop(60){yield;}}
		else{RegularSpellCardDeclare([ObjRender_GetY(SpellText), 12, 0.135, 12]);}

		
		descent(i in 0..15){
			ObjRender_SetAlpha(SpellInfo, 255/15*i);
			yield;
		}
		Obj_Delete(SpellInfo);
		
		ascent(i in 0..80){
			let endspeed = 0.35+i/6;
			ObjRender_SetX(SpellBG, ObjRender_GetX(SpellBG)+endspeed);
			ObjRender_SetX(SpellText, ObjRender_GetX(SpellText)+endspeed);
			yield;
		}
		
		Obj_Delete(SpellBG);
		Obj_Delete(SpellText);
		
		function SpellcardDeclareMovement(dest){
			while(dest[0]>dest[1]){
				dest[0] = ObjRender_GetY(SpellText);
				mov = min(mov+dest[2], (dest[0]-dest[1])/dest[3]+0.125);
				ObjRender_SetY(SpellBG, dest[0]-mov);
				ObjRender_SetY(SpellText, dest[0]-mov);
				yield;
			}
		}
		
		function RegularSpellCardDeclare(dest){
			SpellcardDeclareMovement(dest);
			FadeInA1(SpellInfo, 25);
			let boss = GetEnemyBossObjectID[0];
			while(!Obj_IsDeleted(boss)){
				ObjSpriteList2D_ClearVertexCount(SpellInfo);
					
				ObjSpriteList2D_SetSourceRect(SpellInfo, 0, 48, 128, 60);
				ObjSpriteList2D_SetDestCenter(SpellInfo);
				ObjRender_SetX(SpellInfo, 382-130);
				ObjSpriteList2D_AddVertex(SpellInfo);
				 
				ObjRender_SetAlpha(SpellBG, Alpha_HUD[0]);
				ObjRender_SetAlpha(SpellText, Alpha_HUD[0]);
				ObjRender_SetAlpha(SpellInfo, Alpha_HUD[0]);
				
				let objScene = GetEnemyBossSceneObjectID;
				let modif = min(1, ((ObjEnemyBossScene_GetInfo(GetEnemyBossSceneObjectID, INFO_TIMERF)+300)/ObjEnemyBossScene_GetInfo(GetEnemyBossSceneObjectID, INFO_ORGTIMERF)));
				bonus = ((sscore*0.20)+(sscore*(modif*0.80)));
				count = GetNumSize(bonus);
				let listNum = DigitToArray(min(99999999, bonus), count);
				
				//Bonus Score
				if(ObjEnemyBossScene_GetInfo(objScene, INFO_PLAYER_SHOOTDOWN_COUNT) +
				ObjEnemyBossScene_GetInfo(objScene, INFO_PLAYER_SPELL_COUNT) == 0){
					ascent(iObj in 0 .. count){
						let num = listNum[iObj];
						ObjRender_SetX(SpellInfo, 382-94-(8*count) + iObj * 7);
						ObjSpriteList2D_SetSourceRect(SpellInfo, num * 8, 64, (num + 1) * 8, 76);
						ObjSpriteList2D_SetDestCenter(SpellInfo);
						ObjSpriteList2D_AddVertex(SpellInfo);
					}
				}else{
						bonus = 0;
						ObjRender_SetX(SpellInfo, 382-131);
						ObjSpriteList2D_SetSourceRect(SpellInfo, 144, 48, 176, 60);
						ObjSpriteList2D_SetDestCenter(SpellInfo);
						ObjSpriteList2D_AddVertex(SpellInfo);
				}
				
				//History
				listNum = DigitToArray(SpellValueGet, scount) ~ [10] ~ DigitToArray(SpellValueAttempt, scount);
					
				ascent(iObj in 0 .. scount*2+1){
					let num = listNum[iObj];
					ObjRender_SetX(SpellInfo, 382-58 + iObj * 8);
					ObjSpriteList2D_SetSourceRect(SpellInfo, num * 8, 64, (num + 1) * 8, 76);
					ObjSpriteList2D_SetDestCenter(SpellInfo);
					ObjSpriteList2D_AddVertex(SpellInfo);
				}
				yield;
			}
			
			if(bonus>=1&&ObjEnemyBossScene_GetInfo(GetEnemyBossSceneObjectID, INFO_TIMERF)>0){
				GotSpellCard(bonus);
				AddScore(bonus);
				if(!IsReplay&&!DEBUG){
					SpellValueGet++;
					SetAreaCommonData("Score", SpellDataGet, SpellValueGet);
					SaveCommonDataAreaA1("Score");
				}
			}else{
				FailedSpellCard;
			}
		}
	}
	
	task SpellAttackEffect(alphamax){
		let alpha = 1;
		let GetCenterX = GetStgFrameWidth/2;
		let GetCenterY = GetStgFrameHeight/2;
		Octagon(GetCenterX*2, GetCenterY*2, -1.15, 180, 1);
		Octagon(GetCenterX*2, GetCenterY*2, 1.05, 240, 0);
		Octagon(GetCenterX*2, GetCenterY*2, 1.05, 295, 0);
		Octagon(GetCenterX/5, GetCenterY/5, 0.75, 170, 1);
		
		ascent (i in 0..5){
			Line(GetCenterX, GetCenterY+i*75-75-95, 1.5);
		}
		ascent (i in 0..5){
			Line(GetCenterX, GetCenterY+i*75-37.5-95, -1.5);
		}
		
		loop(15){yield;}
		ascent(i in 0..20){
			alpha = 0.1+alphamax/20*i;
			yield;
		}
		loop(110){yield;}
		descent(i in 0..20){
			alpha = alphamax/20*i;
			yield;
		}
		
		task Line(mx, my, posinc){
			let objSpellAttack = ObjPrim_Create(OBJ_SPRITE_2D);
			ObjRender_SetBlendType(objSpellAttack, BLEND_ALPHA);
			Obj_SetRenderPriority(objSpellAttack, 0.75);
			ObjPrim_SetTexture(objSpellAttack, img_SpellAttack);
			ObjSprite2D_SetSourceRect(objSpellAttack, 0, 0, 512, 16);
			ObjSprite2D_SetDestRect(objSpellAttack, -256, -8, 256, 8);
			let LineX = 0;
			ObjRender_SetPosition(objSpellAttack, mx, my, 0);
			ObjRender_SetAngleZ(objSpellAttack, -35);
			while(alpha>0){
				LineX += posinc;
				ObjSprite2D_SetSourceRect(objSpellAttack, LineX, 0, 512+LineX, 16);
				ObjRender_SetAlpha(objSpellAttack, alpha);
				yield;
			}
			Obj_Delete(objSpellAttack);
		}
	
		task Octagon(mx, my, spininc, dist, size){
		
			let countVertex = 16;
			let listRadius = [];
			loop(countVertex){
				listRadius = listRadius ~ [0];
			}

			let objOutline = ObjPrim_Create(OBJ_PRIMITIVE_2D);
			ObjPrim_SetPrimitiveType(objOutline, PRIMITIVE_TRIANGLESTRIP);
			ObjPrim_SetVertexCount(objOutline, countVertex);
			ObjRender_SetBlendType(objOutline, BLEND_ALPHA);
			Obj_SetRenderPriority(objOutline, 0.76);
			ObjPrim_SetTexture(objOutline, img_SpellAttack);
	
			ascent (iVert in 0..countVertex/2){
				let left = iVert * 128;
				let indexVert = iVert * 2;
				ObjPrim_SetVertexUVT(objOutline, indexVert + 0, left, 0);
				ObjPrim_SetVertexUVT(objOutline, indexVert + 1, left, 16);
			}			
	
			let frame = 0;
			let rRate = 1;
			let spin = 0;
	
			while(alpha>0){
				spin+=spininc;
				VertexSize;
				ObjRender_SetPosition(objOutline, mx, my, 0);
				ObjRender_SetAngleZ(objOutline, spin);
				ObjRender_SetAlpha(objOutline, alpha);
				frame++;
				yield;
			}
			Obj_Delete(objOutline);
			
			task VertexSize{	
				if(frame>=35){return;}
				ascent (iVert in 0..countVertex/2){
					let indexVert = iVert * 2;
					let angle = (360 / (countVertex / 2 - 1) * iVert);

					let vx1 = listRadius[indexVert] * cos(angle);
					let vy1 = listRadius[indexVert] * sin(angle);
					ObjPrim_SetVertexPosition(objOutline, indexVert + 0, vx1, vy1, 0);

					let vx2 = listRadius[indexVert+1] * cos(angle);
					let vy2 = listRadius[indexVert+1] * sin(angle);
					ObjPrim_SetVertexPosition(objOutline, indexVert + 1, vx2, vy2, 0);

					let dr = (dist * rRate - listRadius[indexVert]) / 16;
					listRadius[indexVert] = listRadius[indexVert] + dr;
					if(frame>size){
						listRadius[indexVert + 1] = listRadius[indexVert + 1] + dr;
					}
				}
			}
		}
	}
}

task GotSpellCard(score){
	PlaySound("se_cardget");
	let path = GetCurrentScriptDirectory ~ "img/frame2.png";
	let objText = ObjPrim_Create(OBJ_SPRITE_2D);
	ObjPrim_SetTexture(objText, path);
	ObjSprite2D_SetSourceRect(objText, 0, 99, 255, 131);
	ObjSprite2D_SetDestCenter(objText);
	Obj_SetRenderPriority(objText, 0.8);
	ObjRender_SetX(objText, GetStgFrameWidth/2);
	ObjRender_SetY(objText, 128);

	let objScore = ObjPrim_Create(OBJ_SPRITE_LIST_2D);
	let count = GetNumSize(score);
	let listNum = DigitToArray(score, count);
	ObjRender_SetBlendType(objScore, BLEND_ALPHA);
	ObjPrim_SetTexture(objScore, pathDigit);
	Obj_SetRenderPriority(objScore, 0.8);
	ObjRender_SetY(objScore, 160);
	
	let lprop = [];
	//alpha, y
	ascent(i in 0..count){
		lprop = lprop~[[0, 0]];
		ControlNumber(i);
	}
	
	loop(80+10*count){
		RenderScore;
		yield;
	}
	descent(i in 0..255/15){
		RenderScore;
		ObjRender_SetScaleY(objScore, max(0, 1*(i/(255/8))));
		ObjRender_SetScaleY(objText, max(0, 1*(i/(255/8))));
		ascent(x in 0..count){
			let lp = lprop[x];
			lp[0] = i*15;
			lprop[x] = lp;
		}
		yield;
	}
	
	ObjSpriteList2D_ClearVertexCount(objScore);
	Obj_Delete(objText);
	Obj_Delete(objScore);

	
	sub RenderScore{
		ObjSpriteList2D_ClearVertexCount(objScore);
		ascent(iObj in 0 .. count){
			let lp = lprop[iObj];
			ObjRender_SetAlpha(objScore, lp[0]);
			let num = listNum[iObj];
			ObjRender_SetX(objScore, GetStgFrameWidth/2 - ((count-1)*12/2)+iObj*12);
			ObjRender_SetY(objScore, 160 + lp[1]);
			ObjSpriteList2D_SetSourceRect(objScore, num*16, 0, (num+1)*16, 20);
			ObjSpriteList2D_SetDestRect(objScore, -8, -10, 8, 10);
			ObjSpriteList2D_AddVertex(objScore);
		}
	}

	task ControlNumber(i){
		loop(13+(count-i)*5){yield;}
		ascent(x in 0..8){
			let lp = lprop[i];
			lp[0] = min(255, lp[0]+255/6);
			lp[1] = lp[1]-3;
			lprop[i] = lp;
			yield;
		}
		ascent(x in 0..4){
			let lp = lprop[i];
			lp[1] = lp[1]+3;
			lprop[i] = lp;
			yield;
		}
	}
}

task FailedSpellCard{
	PlaySound("se_fault");
	let path = GetCurrentScriptDirectory ~ "img/frame2.png";
	let objText = ObjPrim_Create(OBJ_SPRITE_2D);
	ObjPrim_SetTexture(objText, path);
	ObjSprite2D_SetSourceRect(objText, 0, 386, 263, 417);
	ObjSprite2D_SetDestRect(objText, -64, -16, 200, 16);
	Obj_SetRenderPriority(objText, 0.8);
	ObjRender_SetX(objText, GetStgFrameWidth/2-64);
	ObjRender_SetY(objText, 128);


	loop(90){
		yield;
	}
	let mov = 2;
	ascent(i in 0..30){
		mov+=mov/9+0.13;
		ObjRender_SetAlpha(objText, 255-255/30*i);
		ObjRender_SetY(objText, 128+mov);
		ObjRender_SetAngleZ(objText, max(0, i^1.01-1.35));
		yield;
	}
	Obj_Delete(objText);
	loop(230){yield}
	CloseScript(GetOwnScriptID);
}





