

#include"./../../../ds_system/AnimLib.h"

task SetEnemyAnimationA1(Enemy){
	AuraOnBossSingleAnim(Enemy, 255, 16, 64);
	NameOnBossSingleAnim(Enemy, "Yumemi Okazaki");
	
	ascent(i in 0..3){ObjAnim_AddFrameA1(Enemy, ANIM_IDLE, 0, 128*i, 128, 128*(i+1));}
	
	ascent(i in 2..4){ObjAnim_AddFrameA1(Enemy, ANIM_MOVE_RIGHT, 256, 128*i, 384, 128*(i+1));}
	descent(i in 2..4){ObjAnim_AddFrameA1(Enemy, ANIM_MOVEEND_RIGHT, 256, 128*i, 384, 128*(i+1));}
	
	ascent(i in 0..2){ObjAnim_AddFrameA1(Enemy, ANIM_MOVE_LEFT, 256, 128*i, 384, 128*(i+1));}
	descent(i in 0..2){ObjAnim_AddFrameA1(Enemy, ANIM_MOVEEND_LEFT, 256, 128*i, 384, 128*(i+1));}
	
	
	ascent(i in 0..3){ObjAnim_AddFrameA1(Enemy, ANIM_ATTACK, 640, 128*i, 768, 128*(i+1));}
	descent(i in 0..3){ObjAnim_AddFrameA1(Enemy, ANIM_ATTACKEND, 640, 128*i, 768, 128*(i+1));}
	
	ObjAnim_SetLoopPointA1(Enemy, ANIM_MOVE_RIGHT, 1);
	ObjAnim_SetLoopPointA1(Enemy, ANIM_MOVE_LEFT, 1);
	ObjAnim_SetLoopPointA1(Enemy, ANIM_ATTACK, 2);
	ObjAnim_SetSpeedA1(Enemy, ANIM_IDLE, 8);
	ObjAnim_SetSpeedA1(Enemy, ANIM_MOVE_RIGHT, 5);
	ObjAnim_SetSpeedA1(Enemy, ANIM_MOVE_LEFT, 5);
	ObjAnim_SetSpeedA1(Enemy, ANIM_ATTACK, 9);
	ObjAnim_StartAnimationA2(Enemy, 5, 1.75);
}


